" Design
Plug 'vim-airline/vim-airline'
" PLUGIN: AIRLINE
let g:airline_powerline_fonts=1
" disable automatically refreshing the mux statusbar since it breaks tmux
" prefix highlighting. Instead, when changing vim statusbar just create
" snapshot with :TmuxlineSnapshot file and stick it into tmux config manually
let g:airline#extensions#tmuxline#enabled = 1
" custom preset with left-justified window list
Plug 'vim-airline/vim-airline-themes'

Plug 'edkolev/tmuxline.vim'
" PLUGIN: TMUXLINE
let g:tmuxline_preset = {
  \'a'       : '#S',
  \'b'       : '#(whoami)',
  \'c'       : '#I:#P',
  \'win'     : '#I #W',
  \'cwin'    : [' ', '#I #W'],
  \'x'       : '#{?client_prefix,#[fg=colour232]#[bg=brightblue],} %H:%M:%S',
  \'y'       : '%d-%b-%y',
  \'z'       : '#H',
  \'options' : {}}

" Colorschemes
Plug 'chriskempson/base16-vim'
Plug 'reedes/vim-colors-pencil'
Plug 'rakr/vim-togglebg'

" Enable italics for colorschemes that support them
let g:gruvbox_italic=1
let g:one_allow_italics=1
let g:pencil_terminal_italics=1

" per this discussion: https://github.com/junegunn/vim-plug/issues/300
autocmd VimEnter * colorscheme base16-gruvbox-dark-medium
